#!/usr/bin/env python3

# seems to work with python 2 _and_ 3

import os
import sys
import collections


# dictData[#Threads][packageSize]
dictData = {}


def parseLine(line):
    columns = line.split('||')
    if len(columns) > 3:
        thread = None
        psize  = None
        fps    = '--'

        try:
            thread = int(columns[1].strip())
        except ValueError:
            pass

        try:
            psize = int(columns[3].strip())
        except ValueError:
            pass

        try:
            if len(columns) > 4:
                fps = int(columns[4].strip())
        except ValueError:
            pass

        if thread is not None and psize is not None:
            if thread not in dictData:
                dictData[thread] = {}

            dictData[thread][psize] = fps
            # print('%d, %d -> %s' % (psize, thread, fps))


def printCSV():
    if len(dictData) > 0:
        packetSizeSet = set()

        for t in dictData:
            for ps in dictData[t]:
                packetSizeSet.add(ps)

        packetSizeSet = sorted(packetSizeSet)

        # print header line
        for t in dictData:
            for ps in packetSizeSet:
                sys.stdout.write(';' + str(ps))
            sys.stdout.write('\n')
            break

        for t in dictData:
            # print thread number
            sys.stdout.write(str(t))

            # print fps data
            for ps in packetSizeSet:
                if dictData[t][ps] is not None:
                    sys.stdout.write(';' + str(dictData[t][ps]))
                else:
                    sys.stdout.write(';--')

            sys.stdout.write('\n')


def inSet(ps):
    return True

    if ps in {1, 2, 4, 6, 8, 10, 15, 20, 25, 30, 40, 50, 60, 70, 80}:
        return True
    else:
        return False


def printLatex():
    if len(dictData) > 0:
        sys.stdout.write("\\begin{tabular}{|l|")

        # print header line
        for t in dictData:
            for ps in dictData[t]:
                if ps in inSet(ps):
                    sys.stdout.write("c")
            sys.stdout.write("|}\n")
            sys.stdout.write("  \\hline\n  ")
            for ps in dictData[t]:
                if ps in inSet(ps):
                    sys.stdout.write("    & \\textbf{" + str(ps) + "}")
            sys.stdout.write("\\\\\n  \\hline\n")
            break

        for t in dictData:
            # print thread number
            sys.stdout.write("    " + str(t))

            # print fps data
            for ps in dictData[t]:
                if ps in inSet(ps):
                    sys.stdout.write(" & " + str(dictData[t][ps]))
            sys.stdout.write(' \\\\\n')

        sys.stdout.write("  \\hline\n")
        sys.stdout.write("\\end{tabular}\n")


def start():
    # check current working directory for *.out files
    for filename in os.listdir(os.getcwd()):
        if filename.endswith('.out'):
            with open(filename, "r") as myfile:
                for line in myfile.readlines():
                    parseLine(line)





start()

# print parsed data!
printCSV()
# printLatex()
