
#include "color.h"
#include "math_approx.h"
#include <stdlib.h>


bool colorEqualsRGB(uint8_t * color_1, uint8_t * color_2) {
    return (color_1[1] == color_2[1] && 
            color_1[2] == color_2[2] && 
            color_1[3] == color_2[3]);
}

//  https://en.wikipedia.org/wiki/Euclidean_distance
//  https://en.wikipedia.org/wiki/Color_difference#CIE76
uint16_t colorDistanceRGB(uint8_t * color_1, uint8_t * color_2) {
    return  (approx_squareroot(
                approx_square(abs(color_1[0] - color_2[0])) + 
                approx_square(abs(color_1[1] - color_2[1])) + 
                approx_square(abs(color_1[2] - color_2[2]))));
}

void colorSetPixelRGBA(uint8_t * pixel, uint8_t * color) {
    for (int i = 0; i <= 3; i++)
        pixel[i] = color[i];
}
