
#include <stdint.h>
#include <libavformat/avformat.h>

#ifndef IMAGE_H
#define IMAGE_H


enum ColorRange{
    COLOR_UNKNOWN   = 0,
    COLOR_GREY      = 1,
    COLOR_RGB       = 3,
    COLOR_RGBA      = 4,
};

typedef enum ColorRange imgCRange;


typedef struct _pictureData {
    uint8_t *       raw;
    uint8_t **      rowPointers;
    uint16_t        width;          // Max Image size is 65025 x 65025.
    uint16_t        height;         // This should be enough
    AVPicture       yuvFrame;
    int             lineSize[4];
    enum ColorRange color;
} pictureData;

typedef pictureData* pictureDataP;

void image_alloc_avPicture(pictureDataP image, enum AVPixelFormat pixfmt);
pictureDataP image_new_only_avPicture(uint16_t width, uint16_t height, enum AVPixelFormat pixfmt);
pictureDataP image_new(uint16_t width, uint16_t height, enum ColorRange color);
pictureDataP image_copy(pictureDataP src,pictureDataP dst);
int recopyImage(pictureDataP src, pictureDataP dst);
void image_free_raw(pictureDataP ptr);
void image_free(pictureDataP ptr);


#endif
