
#include <stdint.h>

#ifndef MATH_APPROX_H
#define MATH_APPROX_H


/**
 * squares a number
 * @performance O(1)
 * @param approx value which will be squared; 0 <= approx <= 255
 * @return the square of approx as integer; 0 <= value <= 65025
 */
uint16_t approx_square(uint8_t approx);

/**
 * extracts the second root
 * @performance O(1)
 * @param approx value which will be extracts; 0 <= approx <= 255
 * @return the square root of approx as integer; 0 <= value <= 196607
 */
uint16_t approx_squareroot(uint16_t approx);


#endif
