
#include "pipeline.h"
#include <stdint.h>

#ifndef MIN_PRIORITY_QUEUE_H
#define MIN_PRIORITY_QUEUE_H


typedef struct heapNode {
    uint64_t        value;
    pipelinePacketP data;
} heapNode;

typedef struct PQ {
    heapNode*   heap;
    uint16_t    size;
} PQ;


/**
 * initializes a new queue with a specific size 
 * @param q the queue which will be initialized
 * @param size the size of the queue
 */
void initializeQueue(PQ *q, uint16_t size);

/**
 * adds a new heapNode to the queue
 * @param q the queue which will get the node
 * @param node the node which will be added to the queue
 */
void enqueue(PQ *q, heapNode node);

/**
 * returns the next element and removes it from the queue
 * @param q the queue which will be dequeued from
 * @return the next heap element
 */
heapNode dequeue(PQ *q);

// TODO: rename to "top"? -> stack-äquivalent
/**
 * returns the next element of the queue
 * @param q the queue which will be looked at
 * @return the next heap element
 */
heapNode touch(PQ *q);


#endif
