
#include <stdint.h>
#include <stdarg.h>
#include <stdbool.h>
#include <glib.h>
#include "ffmpegio.h"

#ifndef PNGEDGEDETECT_H
#define PNGEDGEDETECT_H

// PackageProcessStruct
/**
 * @brief 
 * Context struct for a worker thread
 * 
 */
typedef struct packetProcess {
    struct SwsContext * rgb2yuv; /**<  */
    struct SwsContext * yuv2rgb; /**<  */
    GAsyncQueue * inqueue ; /**<  */
    GAsyncQueue * outqueue ; /**<  */
} * packetProcessP;

// MP Global Vars
extern int32_t myRank;
extern int32_t worldSize;
extern bool multiNodeMode;

// Video I/O Structs
ffmpegIOS   * ffmpeg_io_input,      // input file
            * ffmpeg_io_output;     // output file

// Function Export
void abort_(const char * s, ...);
void soccerLog(const char * s, ...);


extern sig_atomic_t queueFillerExited;
extern sig_atomic_t packetprocessor;
extern sig_atomic_t packetsIn;
extern sig_atomic_t packetsOut;
extern uint16_t queue_max_size;

#endif
